# cwltool.procgenerator

## Classes

`ProcessGeneratorJob` | Result of ProcessGenerator.job().
`ProcessGenerator` | Abstract CWL Process.

## Module Contents

class cwltool.procgenerator.ProcessGeneratorJob(procgenerator)

  Result of ProcessGenerator.job().

  Parameters:

    procgenerator (ProcessGenerator)

  procgenerator
  jobout: cwl_utils.types.CWLObjectType | None = None
  processStatus: str | None = None
  receive_output(jobout, processStatus)

    Process the results.

    Parameters:

      - jobout (cwl_utils.types.CWLObjectType | None)

      - processStatus (str)

    Return type:

      None

  job(job_order, output_callbacks, runtimeContext)
    Parameters:

      - job_order (cwl_utils.types.CWLObjectType)

      - output_callbacks (cwltool.utils.OutputCallbackType)

      - runtimeContext (cwltool.context.RuntimeContext)

    Return type:

      cwltool.utils.JobsGeneratorType

class cwltool.procgenerator.ProcessGenerator(toolpath_object, loadingContext)

  Bases: `cwltool.process.Process`

  Abstract CWL Process.

  Parameters:

    - toolpath_object (ruamel.yaml.comments.CommentedMap)

    - loadingContext (cwltool.context.LoadingContext)

  loadingContext: cwltool.context.LoadingContext
  job(job_order, output_callbacks, runtimeContext)
    Parameters:

      - job_order (cwl_utils.types.CWLObjectType)

      - output_callbacks (cwltool.utils.OutputCallbackType)

      - runtimeContext (cwltool.context.RuntimeContext)

    Return type:

      cwltool.utils.JobsGeneratorType

  result(job_order, jobout, runtimeContext)
    Parameters:

      - job_order (cwl_utils.types.CWLObjectType)

      - jobout (cwl_utils.types.CWLObjectType)

      - runtimeContext (cwltool.context.RuntimeContext)

    Return type:

      tuple[cwltool.process.Process, cwl_utils.types.CWLObjectType]